with Standard_Floating_Numbers;         use Standard_Floating_Numbers;
with Standard_Complex_Numbers;          use Standard_Complex_Numbers;
with Standard_Complex_Matrices;         use Standard_Complex_Matrices;

package Standard_Moving_Planes is

  function Rotate ( A : Matrix; theta : double_float;
                    i1,i2 : natural ) return Matrix;

  -- DESCRIPTION :
  --   Rotates coordinates i1 and i2 of the plane A around theta.

  function Rotating_Plane ( A : Matrix; i1,i2 : natural;
                            t : Complex_Number ) return Matrix;

  -- DESCRIPTION :
  --   Rotates coordinates i1 and i2 of A around the angle 2*PI*t.

  function Moving_Plane ( A,B : Matrix; t : Complex_Number ) return Matrix;

  -- DESCRIPTION :
  --   Returns the matrix (1-t)*A + t*B.

  function Moving_Plane ( A,B : Matrix; gamma,t : Complex_Number )
                        return Matrix;

  -- DESCRIPTION :
  --   Returns the matrix [(1-t) + gamma*t*(1-t)]*A + t*B.

end Standard_Moving_Planes;
