with text_io,integer_io;                  use text_io,integer_io;
with Communications_with_User;            use Communications_with_User;
with Standard_Complex_Poly_Systems;       use Standard_Complex_Poly_Systems;
with Standard_Complex_Poly_Systems_io;    use Standard_Complex_Poly_Systems_io;
with Witness_Points,Witness_Points_io;    use Witness_Points,Witness_Points_io;

procedure ts_embed is

-- DESCRIPTION :
--   Test on slicing and embedding polynomial systems.

  lp : Link_to_Poly_Sys;
  file : file_type;
  k : natural;
  ans : character;

begin
  new_line;
  put_line("Slice and embed a system of polynomial equations.");
  new_line;
  get(lp);
  new_line;
  put_line("Reading the name of the output file.");
  Read_Name_and_Create_File(file);
  new_line;
  put("Give the number of slices to add to the system : "); get(k);
  Add_Embed_Symbols(k);
  put("Consider the slack variables as dummies ? (y/n) ");
  Ask_Yes_or_No(ans);
  new_line;
  put_line("See the output file for the embedded system...");
  new_line;
  declare
    embedded : Poly_Sys(lp'first..lp'last+k);
  begin
    if ans = 'y'
     then embedded := Embed_with_Dummies(lp.all,k);
     else embedded := Slice_and_Embed(lp.all,k);
    end if;
    put_line(file,embedded);
  end;
  Close(file);
end ts_embed;
