with Interfaces.C;                      use Interfaces.C;

package body Assignments_in_Ada_and_C is

  procedure Assign ( this : in integer; to_that : in C_intarrs.Pointer ) is

    val : C_Integer_Array(0..0) := C_intarrs.Value(to_that);

  begin
    val(0) := Interfaces.C.int(this);
    C_intarrs.Copy_Array(val(0)'unchecked_access,to_that,1);
  end Assign;

  procedure Assign ( this : in C_intarrs.Pointer; to_that : out integer ) is

    val : C_Integer_Array(0..0) := C_intarrs.Value(this);
 
  begin
    to_that := integer(val(0));
  end Assign;

  procedure Assign ( this : in double_float;
                     to_that : in C_dblarrs.Pointer ) is

    val : C_Double_Array(0..0) := C_dblarrs.Value(to_that);

  begin
    val(0) := Interfaces.C.double(this);
    C_dblarrs.Copy_Array(val(0)'unchecked_access,to_that,1);
  end Assign;

  procedure Assign ( this : in C_dblarrs.Pointer;
                     to_that : out double_float ) is

    val : C_Double_Array(0..0) := C_dblarrs.Value(this);
 
  begin
    to_that := double_float(val(0));
  end Assign;

  procedure Assign ( ada_cf : in Complex_Number;
                     c_cf : in C_dblarrs.Pointer ) is

    val : C_Double_Array(0..1);

  begin
    val(0) := Interfaces.C.double(REAL_PART(ada_cf));
    val(1) := Interfaces.C.double(IMAG_PART(ada_cf));
    C_dblarrs.Copy_Array(val(0)'unchecked_access,c_cf,2);
  end Assign;

  procedure Assign ( c_cf : in C_dblarrs.Pointer;
                     ada_cf : out Complex_Number ) is

    val : C_Double_Array(0..1) := C_dblarrs.Value(c_cf,2);

  begin
    ada_cf := Create(double_float(val(0)),double_float(val(1)));
  end Assign;

  procedure Assign ( ada_d : in Standard_Natural_Vectors.Vector;
                     c_d : in C_intarrs.Pointer ) is

    nd : constant natural := ada_d'last;
    val : C_Integer_Array(0..Interfaces.C.size_t(nd-1));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in ada_d'range loop
      val(ind) := Interfaces.C.int(ada_d(i));
      ind := ind + 1;
    end loop;
    C_intarrs.Copy_Array(val(0)'unchecked_access,c_d,
                         Interfaces.C.ptrdiff_t(nd));
  end Assign;

  procedure Assign ( ada_d : in Standard_Integer_Vectors.Vector;
                     c_d : in C_intarrs.Pointer ) is

    nd : constant natural := ada_d'last;
    val : C_Integer_Array(0..Interfaces.C.size_t(nd-1));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in ada_d'range loop
      val(ind) := Interfaces.C.int(ada_d(i));
      ind := ind + 1;
    end loop;
    C_intarrs.Copy_Array(val(0)'unchecked_access,c_d,
                         Interfaces.C.ptrdiff_t(nd));
  end Assign;

  procedure Assign ( ada_d : in Standard_Floating_Vectors.Vector;
                     c_d : in C_dblarrs.Pointer ) is

    nd : constant natural := ada_d'last;
    val : C_Double_Array(0..Interfaces.C.size_t(nd-1));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in ada_d'range loop
      val(ind) := Interfaces.C.double(ada_d(i));
      ind := ind + 1;
    end loop;
    C_dblarrs.Copy_Array(val(0)'unchecked_access,c_d,
                         Interfaces.C.ptrdiff_t(nd));
  end Assign;

  procedure Assign ( ada_d : in Standard_Complex_Vectors.Vector;
                     c_d : in C_dblarrs.Pointer ) is

    v_n : constant natural := ada_d'last;
    val : C_Double_Array(0..Interfaces.C.size_t(2*v_n-1))
        := C_dblarrs.Value(c_d);
    ind : Interfaces.C.size_t := 0;

  begin
    for i in 1..v_n loop
      val(ind) := Interfaces.C.double(REAL_PART(ada_d(i)));
      ind := ind + 1;
      val(ind) := Interfaces.C.double(IMAG_PART(ada_d(i)));
      ind := ind + 1;
    end loop;    
    C_dblarrs.Copy_Array(val(0)'unchecked_access,c_d,
                         Interfaces.C.ptrdiff_t(2*v_n));
  end Assign;

  procedure Assign ( v_n : in natural; c_d : in C_intarrs.Pointer;
                     ada_d : out Standard_Natural_Vectors.Vector ) is

    val : C_Integer_Array(0..Interfaces.C.size_t(v_n-1))
        := C_intarrs.Value(c_d,Interfaces.C.ptrdiff_t(v_n));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in 1..v_n loop
      ada_d(i) := natural(val(ind));
      ind := ind + 1;
    end loop;
  end Assign;

  procedure Assign ( v_n : in natural; c_d : in C_intarrs.Pointer;
                     ada_d : out Standard_Integer_Vectors.Vector ) is

    val : C_Integer_Array(0..Interfaces.C.size_t(v_n-1))
        := C_intarrs.Value(c_d,Interfaces.C.ptrdiff_t(v_n));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in 1..v_n loop
      ada_d(i) := integer(val(ind));
      ind := ind + 1;
    end loop;
  end Assign;

  procedure Assign ( v_n : in natural; c_d : in C_dblarrs.Pointer;
                     ada_d : out Standard_Floating_Vectors.Vector ) is

    val : C_Double_Array(0..Interfaces.C.size_t(v_n-1))
        := C_dblarrs.Value(c_d,Interfaces.C.ptrdiff_t(v_n));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in 1..v_n loop
      ada_d(i) := double_float(val(ind));
      ind := ind + 1;
    end loop;
  end Assign;

  procedure Assign ( v_n : in natural; c_d : in C_dblarrs.Pointer;
                     ada_d : out Standard_Complex_Vectors.Vector ) is

    val : C_Double_Array(0..Interfaces.C.size_t(v_n-1))
        := C_dblarrs.Value(c_d,Interfaces.C.ptrdiff_t(v_n));
    ind : Interfaces.C.size_t := 0;

  begin
    for i in 1..v_n/2 loop
      ada_d(i) := 
         Create(double_float(val(ind)),double_float(val(ind+1)));
      ind := ind + 2;
    end loop;
  end Assign;

end Assignments_in_Ada_and_C;
