with text_io;                          use text_io;
with PHCpack_Operations;               use PHCpack_Operations;
with PHCpack_Operations_io;            use PHCpack_Operations_io;

function C_to_PHCpack ( job : integer ) return integer is

  procedure Write_Menu is
  begin
    new_line;
    put_line("MENU to the operations in PHCpack :");
    put_line("  0. displays this menu;");
    put_line("  1. read target system;");
    put_line("  2. write target system;");
    put_line("  3. read start system;");
    put_line("  4. write start system;");
    put_line("  5. write start solutions;");
    put_line("  6. solve by homotopy continuation;");
    put_line("  7. write the target solutions;");
    put_line("  8. clear all data;");
    put_line("  9. define the output file.");
  end Write_Menu;

begin
  case job is
    when 0 => Write_Menu;
    when 1 => PHCpack_Operations_io.Read_Target_System;
    when 2 => PHCpack_Operations_io.Write_Target_System;
    when 3 => PHCpack_Operations_io.Read_Start_System;
    when 4 => PHCpack_Operations_io.Write_Start_System;
    when 5 => PHCpack_Operations_io.Write_Start_Solutions;
    when 6 => PHCpack_Operations.Solve_by_Homotopy_Continuation;
    when 7 => PHCpack_Operations_io.Write_Target_Solutions;
    when 8 => PHCpack_Operations.Clear;
    when 9 => PHCpack_Operations.Define_Output_File;
    when others => put_line("  Sorry, this operation is not defined.");
                   return 1;
  end case;
  return 0;
end C_to_PHCpack;
