function C_to_PHCpack ( job : integer ) return integer;

-- DESCRIPTION :
--   Interactive gateway to the core operations in PHCpack.
--   Calling this routine with n = 0 displays the menu.

-- ON ENTRY :
--   job      = 0 : displays the menu of available operations;
--            = 1 : read target polynomial system;
--            = 2 : write target polynomial system;
--            = 3 : read start polynomial system;
--            = 4 : write start polynomial system;
--            = 5 : write start solutions;
--            = 6 : solve by homotopy continuation;
--            = 7 : write the target solutions;
--            = 8 : clear the data in PHCpack_Operations;
--            = 9 : define the output file.

-- ON RETURN :
--   0 if the operation was successful, otherwise something went wrong,
--   e.g.: job not in the range 0..9.
