with text_io,integer_io;                use text_io,integer_io;
with Standard_Complex_Solutions;        use Standard_Complex_Solutions;
with Standard_Complex_Solutions_io;     use Standard_Complex_Solutions_io;
with Solutions_Container;

procedure ts_solcon is

-- DESCRIPTION :
--   This procedure is an interactive test on the operations
--   in the solution container.

  procedure Test_Retrievals is

  -- DESRIPTION :
  --   Test the retrieval of the solutions in the container.

    fail : boolean;
    ind : natural := 0;
    ls : Link_to_Solution;

  begin
    new_line;
    put_line("Testing the retrieval of solutions...");
    new_line;
    put("Number of solutions in the container : ");
    put(Solutions_Container.Length,1); new_line;
    put("Dimension of solution vectors : ");
    put(Solutions_Container.Dimension,1); new_line;
    loop
      ind := ind + 1;
      Solutions_Container.Retrieve(ind,ls,fail);
      exit when fail;
      put("Solution "); put(ind,1); put_line(" :");
      put(ls.all); new_line;
    end loop;
  end Test_Retrievals;

  procedure Test_Additions ( sols : in Solution_List ) is

  -- DESCRIPTION :
  --   Tests the constructors of the container.

    tmp,retrieved : Solution_List;

  begin
    new_line;
    put_line("Testing the addition of solutions...");
    new_line;
    tmp := sols;
    while not Is_Null(tmp) loop
      Solutions_Container.Append(Head_Of(tmp).all);
      tmp := Tail_Of(tmp);
    end loop;
    retrieved := Solutions_Container.Retrieve;
    put_line("The retrieved solution list :");
    if not Is_Null(retrieved)
     then put(Standard_Output,
              Length_Of(retrieved),Head_Of(retrieved).n,retrieved);
    end if;
  end Test_Additions;

  procedure Main is

    sols : Solution_List;

  begin
    new_line;
    put_line("Testing the operations in the solutions container...");
    new_line;
    Read(sols);
    Solutions_Container.Initialize(sols);
    Test_Retrievals;
    Solutions_Container.Clear;
    Test_Additions(sols);
  end Main;

begin
  Main;
end ts_solcon;
