with text_io,integer_io;                use text_io,integer_io;
with Standard_Complex_Polynomials;      use Standard_Complex_Polynomials;
with Standard_Complex_Polynomials_io;   use Standard_Complex_Polynomials_io;
with Standard_Complex_Poly_Systems;     use Standard_Complex_Poly_Systems;
with Standard_Complex_Poly_Systems_io;  use Standard_Complex_Poly_Systems_io;
with Systems_Container;

procedure ts_syscon is

-- DESCRIPTION :
--   This procedure is an interactive testing facility on the
--   operations in the package systems container.

  procedure Test_Retrievals is

  -- DESCRIPTION :
  --   Tests the selectors in the package.

    n : constant natural := Systems_Container.Dimension;
    m : natural;

  begin
    put("Dimension of the system : "); put(n,1); new_line;
    for i in 1..n loop
      m := Systems_Container.Number_of_Terms(i);
      put("Number of terms in polynomial "); put(i,1);
      put(" : "); put(m,1); new_line;
      declare
        p : Poly := Null_Poly;
      begin
        for j in 1..m loop
          declare
            t : Term := Systems_Container.Retrieve_Term(i,j);
          begin
            Add(p,t);
            Clear(t);
          end;
        end loop;
        put(p); new_line;
        put(Systems_Container.Retrieve(i)); new_line;
      end;
    end loop;
  end Test_Retrievals;

  procedure Test_Additions ( p : in Poly_Sys ) is

  -- DESCRIPTION :
  --   Tests the constructors of the package.

    ind : natural;

    procedure Add_Term ( t : in Term; continue : out boolean ) is
    begin
      Systems_Container.Add_Term(ind,t);
      continue := true;
    end Add_Term;
    procedure Add_Terms is new Visiting_Iterator(Add_Term);

  begin
    Systems_Container.Initialize(p'last);
    for i in p'range loop
      ind := i;
      Add_Terms(p(i));
    end loop;
    put_line("The polynomial system : ");
    put(Systems_Container.Retrieve.all);
  end Test_Additions;

  procedure Main is

    lp : Link_to_Poly_Sys;

  begin
    new_line;
    put_line("Testing the operations in the systems container...");
    new_line;
    get(lp);
    Systems_Container.Initialize(lp.all);
    Test_Retrievals;
    Systems_Container.Clear;
    Test_Additions(lp.all);
  end Main;

begin
  Main;
end ts_syscon;
