with C_Integer_Arrays;                  use C_Integer_Arrays;
with C_Double_Arrays;                   use C_Double_Arrays;

function use_c2fac ( job : integer;
                     a : C_intarrs.Pointer;
		     b : C_intarrs.Pointer;
                     c : C_dblarrs.Pointer ) return integer;

-- DESCRIPTION :
--   Provides a gateway from C to the operations in PHCpack
--   to factor pure dimensional solution sets of polynomial systems,
--   using monodromy certified by linear traces.

-- ON ENTRY :
--   job    =  0 : display the menu of all available options;
--   job    =  1 : prompts the user for a witness set,
--                 stores the system in the systems container,
--                 and its solutions in the solutions container,
--                 and returns in a the dimension of the ambient space
--                 and in b the following two numbers:
--                   b[0] : dimension of the solution set;
--                   b[1] : degree of the solution set.
--   job    =  2 : takes the system and the solutions from the containers
--                 and initializes the sampling machine, on input,
--                 the dimension of the witness set must be in a;
--   job    =  3 : assigns the coefficient c[0] + c[1]*I to the
--                 b-th coefficient of the a-th slice;
--   job    =  4 : stores the c[0] + c[1]*I as random gamma constant
--                 for the a-th equation;
--   job    =  5 : compute a new witness set on the new slices;
--   job    =  6 : swaps slices and solution sets to turn back;
--   job    =  7 : copy embedded system from sampler to systems container;
--   job    =  8 : copy first solution list to container;
--   job    = 10 : initializes Monodromy_Permutations with two numbers:
--                   a[0] : number of monodromy loops,
--                   b[0] : degree of the solution component to factor;
--   job    = 11 : store solutions in container to Monodromy_Permutations;
--   job    = 12 : compute permutation by last stored solution list,
--                 and return this new permutation in b;
--   job    = 13 : updates decomposition with a new permutation,
--                 a[0] must contain the dimension and b the permutation;
--   job    = 14 : writes the current decomposition;
--   job    = 15 : applies the linear trace to certify the decomposition.
--
-- ON RETURN :
--   0 if the operation was successful, otherwise something went wrong,
--   e.g.: job not in the right range.
