with text_io,integer_io;                use text_io,integer_io;
with Interfaces.C;                      use Interfaces.C;
with Standard_Floating_Numbers;         use Standard_Floating_Numbers;
with Standard_Complex_Numbers;          use Standard_Complex_Numbers;
with Standard_Floating_Vectors;         use Standard_Floating_Vectors;
with Standard_Complex_Vectors;          use Standard_Complex_Vectors;
with Standard_Complex_Solutions;        use Standard_Complex_Solutions;
with Standard_Complex_Solutions_io;     use Standard_Complex_Solutions_io;
with PHCpack_Operations;
with Solutions_Container;
with Assignments_in_Ada_and_C;          use Assignments_in_Ada_and_C;

function use_solcon ( job : integer;
                      a : C_intarrs.Pointer;
                      b : C_intarrs.Pointer;
                      c : C_dblarrs.Pointer ) return integer is

  function Convert_to_Solution return Link_to_Solution is

  -- DESCRIPTION :
  --   Converts the input parameters into a solution type.

    res : Link_to_Solution;
    v : C_Integer_Array(0..1) := C_intarrs.Value(b,Interfaces.C.ptrdiff_t(2));
    nv : constant natural := natural(v(0));
    dim : Interfaces.C.size_t := Interfaces.C.size_t(2*nv+5);
    sol : C_Double_Array(0..dim-1)
        := C_dblarrs.Value(c,Interfaces.C.ptrdiff_t(dim));
    s : Solution(nv);
    ind : Interfaces.C.size_t := 2;

  begin
    s.t := Create(double_float(sol(0)),double_float(sol(1)));
    s.m := natural(v(1));
    for i in s.v'range loop
      s.v(i) := Create(double_float(sol(ind)),double_float(sol(ind+1)));
      ind := ind + 2;
    end loop;
    s.err := double_float(sol(Interfaces.C.size_t(2*nv+2)));
    s.rco := double_float(sol(Interfaces.C.size_t(2*nv+3)));
    s.res := double_float(sol(Interfaces.C.size_t(2*nv+4)));
    res := new Solution'(s);
    return res;
  end Convert_to_Solution;

begin
  case job is
    when 0 => declare
                sols : Solution_List;
              begin
                Read(sols);
                Solutions_Container.Initialize(sols);
              end;
              return 0;
    when 1 => declare
                sols : Solution_List := Solutions_Container.Retrieve;
              begin
                if not Is_Null(sols)
                 then put(PHCpack_Operations.Retrieve_Output_File,
                          Length_Of(sols),Head_Of(sols).n,sols);
                end if;
              end;
              return 0;
    when 2 => Assign(Solutions_Container.Length,b);
              return 0;
    when 3 => Assign(Solutions_Container.Dimension,b);
              return 0;
    when 4 => declare
                ls : Link_to_Solution;
                v : C_Integer_Array(0..0) := C_intarrs.Value(a);
                k : constant natural := natural(v(0));
                fail : boolean;
              begin
                Solutions_Container.Retrieve(k,ls,fail);
                if fail
                 then return 1;
                 else declare
                        dim : constant natural := 2*ls.n + 5;
                        sol : Standard_Floating_Vectors.Vector(1..dim);
                        ind : natural := 3;
                      begin
                        sol(1) := REAL_PART(ls.t);
                        sol(2) := IMAG_PART(ls.t);
                        Assign(ls.m,b);
                        for i in ls.v'range loop
                          sol(ind) := REAL_PART(ls.v(i));
                          sol(ind+1) := IMAG_PART(ls.v(i));
                          ind := ind + 2;
                        end loop;
                        sol(dim-2) := ls.err;
                        sol(dim-1) := ls.rco;
                        sol(dim)   := ls.res;
                        Assign(sol,c);
                        return 0;
                      end;
                end if;
              end;
    when 5 => declare
                ls : Link_to_Solution := Convert_to_Solution;
                v : C_Integer_Array(0..0) := C_intarrs.Value(a);
                k : constant natural := natural(v(0));
                fail : boolean;
              begin
                Solutions_Container.Replace(k,ls.all,fail);
                Clear(ls);
                if fail
                 then return 1;
                 else return 0;
                end if;
              end;
    when 6 => declare
                ls : Link_to_Solution := Convert_to_Solution;
              begin
                Solutions_Container.Append(ls);
              end;
              return 0;
    when 7 => Solutions_Container.Clear;
              return 0;
    when others => put_line("invalid operation");
                   return 1;
  end case;
end use_solcon;
