with text_io;                           use text_io;
with Interfaces.C;
with Standard_Natural_Vectors;          use Standard_Natural_Vectors;
with Standard_Complex_Polynomials;      use Standard_Complex_Polynomials;
with Standard_Complex_Poly_Systems;     use Standard_Complex_Poly_Systems;
with Standard_Complex_Poly_Systems_io;  use Standard_Complex_Poly_Systems_io;
with PHCpack_Operations;
with Systems_Container;
with Assignments_in_Ada_and_C;          use Assignments_in_Ada_and_C;

function use_syscon ( job : integer;
                      a : C_intarrs.Pointer;
		      b : C_intarrs.Pointer;
                      c : C_dblarrs.Pointer ) return integer is
begin
  case job is
    when 0 => declare
                lp : Link_to_Poly_Sys;
              begin
                new_line;
                put_line("Reading a polynomial system...");
                get(lp);
                Systems_Container.Initialize(lp.all);
              end;
              return 0;
    when 1 => declare
                lp : Link_to_Poly_Sys := Systems_Container.Retrieve;
              begin
                if lp /= null
                 then put(PHCpack_Operations.Retrieve_Output_File,lp.all);
                end if;
              end;
              return 0;
    when 2 => Assign(Systems_Container.Dimension,a);
              return 0;
    when 3 => declare
                v : C_Integer_Array(0..0) := C_intarrs.Value(a);
              begin
                Systems_Container.Initialize(natural(v(0)));
              end;
              return 0;
    when 4 => declare
                v : C_Integer_Array(0..1)
                  := C_intarrs.Value(a,Interfaces.C.ptrdiff_t(2));
                i : constant natural := natural(v(1));
              begin
                Assign(Systems_Container.Number_of_Terms(i),a);
              end;
              return 0;
    when 5 => declare
                v : C_Integer_Array(0..2)
                  := C_intarrs.Value(a,Interfaces.C.ptrdiff_t(3));
                i : constant natural := natural(v(1));
                j : constant natural := natural(v(2));
                t : Term := Systems_Container.Retrieve_Term(i,j);
              begin
                Assign(t.cf,c);
                Assign(t.dg.all,b);
              end;
              return 0;
    when 6 => declare
                v : C_Integer_Array(0..1)
                  := C_intarrs.Value(a,Interfaces.C.ptrdiff_t(2));
                n : constant natural := natural(v(0));
                i : constant natural := natural(v(1));
                e : Vector(1..n);
                t : Term;
              begin
                Assign(c,t.cf);
                Assign(n,b,e);
                t.dg := new Vector'(e);
                Systems_Container.Add_Term(i,t);
              end;
              return 0;
    when 7 => Systems_Container.Clear;
              return 0;
    when others => put_line("invalid operation");
                   return 1;
  end case;
end use_syscon;
