with C_Integer_Arrays;                  use C_Integer_Arrays;
with C_Double_Arrays;                   use C_Double_Arrays;

function use_syscon ( job : integer;
                      a : C_intarrs.Pointer;
		      b : C_intarrs.Pointer;
                      c : C_dblarrs.Pointer ) return integer;

-- DESCRIPTION :
--   Provides a gateway to the systems container.

-- ON ENTRY :
--   job      = 0 : read polynomial system and put in container;
--            = 1 : write the polynomial system in the container;
--            = 2 : return in a[0] the dimension of the polynomial system;
--            = 3 : initializes the container with the dimension in a[0];
--            = 4 : return in a[0] the number of terms in the i-th polynomial;
--            = 5 : return in c the coefficient (real and imaginary part),
--                     and in b the exponent vector (i = a[1], j = a[2])
--                  of the j-th term in the i-th polynomial;
--            = 6 : add to the i-th polynomial the term with coefficient
--                      in c and exponent vector in b;
--            = 7 : the systems container is cleared;
--   a        memory allocated for array of integers, a = (n,i,j),
--            where n is the dimension,
--                  i is index to the polynomial in the system to work on;
--                  j is index to the mononomial in the i-th polynomial;
--   b        memory allocated for array of integers, used for exponents;
--   c        memory allocated for array of double floating-point numbers,
--            used for real and imaginary part of complex coefficient.

-- ON RETURN :
--   0 if the operation was successful, otherwise something went wrong,
--   e.g.: indices to monomial out of range, or job not in range 0..7.
