with text_io,integer_io;                 use text_io,integer_io;
with Communications_with_User;           use Communications_with_User;
with Standard_Complex_Solutions;         use Standard_Complex_Solutions;
with Standard_Complex_Solutions_io;      use Standard_Complex_Solutions_io;

procedure Split_or_Join_Solution_Lists is

  procedure Concat ( sols,sols_last : in out Solution_List;
                     insols : in Solution_List ) is

  -- DESCRIPTION :
  --   Concatenates the list insols to the list sols.

    tmp : Solution_List := insols;

  begin
    while not Is_Null(tmp) loop
      Append(sols,sols_last,Head_Of(tmp));
      tmp := Tail_Of(tmp);
    end loop;
  end Concat;

  procedure Split_Solution_List is

  -- DESCRIPTION :
  --   The user needs to provide the name of an input file
  --   and is then prompted for names of output files of solutions.

    outfile,infile : file_type;
    insols,tmp : Solution_List;
    len,nb : natural;
    cnt : natural := 1;
    ans : character;

  begin
    new_line;
    put_line("Splitting a list of solutions.");
    new_line;
    put_line("Reading the name of the input file.");
    Read_Name_and_Open_File(infile);
    put("Reading ... ");
    get(infile,insols);
    Close(infile);
    put_line("done");
    len := Length_Of(insols);
    tmp := insols;
    loop
      new_line;
      put("Give #solutions (<= "); put(len,1);
      put(") for list "); put(cnt,1); put(" : ");
      get(nb); skip_line;
      new_line;
      put("Reading the name of list "); put(cnt,1); put_line(".");
      Read_Name_and_Create_File(outfile);
      declare
        outsols,outsols_last : Solution_List;
      begin
        put("Collecting ... ");
        for i in 1..nb loop
          Append(outsols,outsols_last,Head_Of(tmp));
          exit when Is_Null(tmp);
        end loop;
        put("writing ... ");
        put(outfile,Length_Of(outsols),Head_Of(outsols).n,outsols);
        put("done with list "); put(cnt,1); put_line(".");
      end;
      Close(outfile);
      len := len - nb;
      exit when (len = 0);
      new_line;
      put("Do you want to split off more lists ? (y/n) ");
      Ask_Yes_or_No(ans);
      exit when (ans /= 'y');
      cnt := cnt+1;
    end loop;
  end Split_Solution_List;

  procedure Join_Solution_Lists is

  -- DESCRIPTION :
  --   The user needs to provide the name of an output file
  --   and is then prompted for names of input files of solutions.

    outfile,infile : file_type;
    sols,sols_last : Solution_List;
    cnt : natural := 1;
    ans : character;

  begin
    new_line;
    put_line("Joining lists of solutions.");
    new_line;
    put_line("Reading the name of the output file.");
    Read_Name_and_Create_File(outfile);
    loop
      new_line;
      put("Reading the name of list "); put(cnt,1); put_line(".");
      Read_Name_and_Open_File(infile);
      declare
        insols : Solution_List;
      begin
        put("Reading ... ");
        get(infile,insols);
        put("concatenating ... ");
        Concat(sols,sols_last,insols);     
        put("done with list "); put(cnt,1); put_line(".");
      end;
      Close(infile);
      new_line;
      put("Do you want to join more lists ? (y/n) ");
      Ask_Yes_or_No(ans);
      exit when (ans /= 'y');
      cnt := cnt+1;
    end loop;
    new_line;
    put_line("Writing all solutions to the output file...");
    new_line;
    put(outfile,Length_Of(sols),Head_Of(sols).n,sols);
    Close(outfile);
  end Join_Solution_Lists;

  procedure Main is

    ans : character;

  begin
    new_line;
    put_line("MENU for splitting or joining solution lists :");
    put_line("  1. split one list into several lists;");
    put_line("  2. join several lists into one list.");
    put("Type 1 or 2 to select your choice : ");
    Ask_Alternative(ans,"12");
    case ans is
      when '1' => Split_Solution_List;
      when '2' => Join_Solution_Lists;
      when others => put_line("Invalid option.");
    end case;
  end Main;

begin
  Main;
end Split_or_Join_Solution_Lists;
