with text_io;                            use text_io;
with Multprec_Integer_Numbers;           use Multprec_Integer_Numbers;

package Multprec_Integer_Numbers_io is

-- DESCRIPTION :
--   This package provides basic input/output routines for integer numbers
--   of arbitrary length.

  procedure get ( lc : in out character; i : in out Integer_Number );
  procedure get ( file : in file_type;
                  lc : in out character;  i : in out Integer_Number );
  procedure get ( i : in out Integer_Number );
  procedure get ( file : in file_type; i : in out Integer_Number );

  -- DESCRIPTION :
  --   Reads a string of numbers and returns a natural number.
  --   The parameter lc is the leading character on entry.
  --   On return it is the last character read.

  procedure put ( i : in Integer_Number );
  procedure put ( file : in file_type; i : in Integer_Number );

  -- DESCRIPTION :
  --   Writes the number on Standard Output or on file.

  procedure put ( i : in Integer_Number; dp : in natural );
  procedure put ( file : in file_type;
                  i : in Integer_Number; dp : in natural );

  -- DESCRIPTION :
  --   Writes the number on Standard Output or on file, using at least
  --   dp decimal places.  If the number needs less space in its display,
  --   then blanks are added in front of the number.

end Multprec_Integer_Numbers_io;
