with text_io;                            use text_io;
with Standard_Complex_Polynomials;       use Standard_Complex_Polynomials;
with Standard_Complex_Poly_Systems;      use Standard_Complex_Poly_Systems;

package Standard_Complex_Poly_Strings is

-- DESCRIPTION :
--   This package converts polynomials in several variables and with
--   standard complex floating-point coefficients into strings, and
--   vice versa.

  function Parse ( n : natural; s : string ) return Poly;

  -- DESCRIPTION :
  --   This function returns a polynomial in n variables,
  --   as a result of parsing the string s.

  function Parse ( n,m : natural; s : string ) return Poly_Sys;

  -- DESCRIPTION :
  --   Returns a system of n polynomials in m variables.

  function Write ( p : Poly ) return string;

  -- DESCRIPTION :
  --   This function writes the polynomial to a string.

  function Write ( p : Poly_Sys ) return string;

  -- DESCRIPTION :
  --   This function writes the polynomial system to a string.

end Standard_Complex_Poly_Strings;
