with text_io,integer_io;               use text_io,integer_io;
with Communications_with_User;         use Communications_with_User;
with Symbol_Table;
with Standard_Complex_Polynomials;     use Standard_Complex_Polynomials;
with Standard_Complex_Polynomials_io;  use Standard_Complex_Polynomials_io;
with Standard_Complex_Poly_Systems;    use Standard_Complex_Poly_Systems;
with Standard_Complex_Poly_Systems_io; use Standard_Complex_Poly_Systems_io;
with Standard_Complex_Poly_Strings;    use Standard_Complex_Poly_Strings;

procedure ts_parse is

-- DESCRIPTION :
--   Test on the conversion between strings and polynomials.

  procedure Parse_Polynomial is

    n : natural;
    s : constant string := Read_String;
    p : Poly;

  begin
    put("Give the number of variables : "); get(n);
    p := Parse(n,s);
    put_line("The parsed polynomial : "); put(p); new_line;
    Symbol_Table.Init(n);
    put("Give a polynomial : "); get(p);
    put("-> Your polynomial : "); put(p);
    new_line;
    declare
      ps : constant string := Write(p);
      sp : Poly;
    begin
      put("The polynomial : "); put(ps); new_line;
      sp := Parse(n,ps);
      put("-> After parsing : "); put(sp); new_line;
    end;
  end Parse_Polynomial;

  procedure Parse_System is

    lp : Link_to_Poly_Sys;

  begin
    get(lp);
    declare
      sp : constant string := Write(lp.all);
      n : constant natural := lp'last;
      m : constant natural := Number_of_Unknowns(lp(lp'last));
      p : Poly_Sys(1..n);
    begin
      put_line("The polynomial system as string : ");
      put(sp); new_line;
      p := Parse(n,m,sp);
      put_line("The system after parsing : "); put(p);
    end;
  end Parse_System;

  procedure Main is

    ans : character;

  begin
    new_line;
    put_line("Conversion of strings into polynomials, and vice versa.");
    new_line;
    put_line("Choose one of the following : ");
    put_line("  1. test parsing of one polynomial;");
    put_line("  2. parse a polynomial system.");
    put("Type 1 or 2 to make your choice : ");
    Ask_Alternative(ans,"12");
    new_line;
    case ans is
      when '1' => Parse_Polynomial;
      when '2' => Parse_System;
      when others => null;
    end case;
  end Main;

begin
  Main;
end ts_parse;
