with text_io;                            use text_io;
with Standard_Complex_Poly_Systems;      use Standard_Complex_Poly_Systems;
with Standard_Complex_Solutions;         use Standard_Complex_Solutions;

procedure Black_Box_Fewnomial_Solver
            ( file : in file_type; p : in Poly_Sys;
              sols : out Solution_List; fail : out boolean );

-- DESCRIPTION :
--   Determines first whether the system p has only as many distinct
--   monomials as the number of variables plus one.  If this is not,
--   then fail is set to true and the system is not "fewnomial".
--   Otherwise, fail will most likely be false, and all solutions
--   to p will be in the list sols on return.
--   When fail is not false on return, the results of the root
--   refiner will be written to file.
