with text_io;                            use text_io;
with Communications_with_User;           use Communications_with_User;
with Standard_Complex_Poly_Systems;      use Standard_Complex_Poly_Systems;
with Standard_Complex_Poly_Systems_io;   use Standard_Complex_Poly_Systems_io;
with Standard_Complex_Solutions;         use Standard_Complex_Solutions;
with Black_Box_Fewnomial_Solver;

procedure ts_fewsolve is

-- DESCRIPTION :
--   Test on the resolution of fewnomial systems.

  ans : character;
  lp : Link_to_Poly_Sys;
  sols : Solution_List;
  fail : boolean;

begin
  loop
    get(lp);
    Black_Box_Fewnomial_Solver(Standard_Output,lp.all,sols,fail);
    if fail
     then put_line("The system has too many terms ...");
          put_line("  or some other failure occurred ...");
    end if;
    Clear(sols); Clear(lp);
    put("Do you want more tests ? (y/n) "); Ask_Yes_or_No(ans);
    exit when ans /= 'y';
  end loop;
end ts_fewsolve;
