with Standard_Natural_Vectors;          use Standard_Natural_Vectors;

package Checker_Boards is

-- DESCRIPTION :
--   This package defines a checker board and provides some
--   operations regarding placing checkers on the board.

  type Board is array ( integer range <>, integer range <> ) of character;

  procedure Initialize ( b : in out Board );

  -- DESCRIPTION :
  --   Initializes the board to spaces.

  function Configuration ( p : Vector ) return Board;
  
  -- DESCRIPTION :
  --   Returns the configuration corresponding to the permutation p.

  function Permutation ( b : Board ) return Vector;

  -- DESCRIPTION :
  --   Returns the permutation corresponding to the given board.

  procedure Place_White ( b : in out Board; r,c : in Vector );

  -- DESCRIPTION :
  --   Places white checkers given by rows r and columns c
  --   on the board b.

  function Configuration ( p,r,c : Vector ) return Board;

  -- DESCRIPTION :
  --   Returns the configuration defined by black checkers in p
  --   and white checkers given by r and c.

end Checker_Boards;
