with Standard_Natural_Vectors;          use Standard_Natural_Vectors;
with Checker_Boards;                    use Checker_Boards;

package Checker_Boards_io is

-- DESCRIPTION :
--   This package offers some simple input and output facilities
--   for permutations and checker boards.

  procedure Write ( b : in Board );

  -- DESCRIPTION :
  --   Writes the board to standard output.

  procedure Read_Permutation ( p : out Vector );

  -- DESCRIPTION :
  --   Prompts the user to give a permutation vector.

  procedure Write_Permutation ( p : in Vector );

  -- DESCRIPTION :
  --   Writes the permutation and the corresponding checker board.

  procedure Write_Coordinates ( rows,cols : in Vector );

  -- DESCRIPTION :
  --   Writes the rows and columns which define the white checkers.

  procedure Write ( b : in Board; p,rows,cols : in Vector );

  -- DESCRIPTION :
  --   Writes the board and the vectors defining the positions
  --   of the black and white checkers.

end Checker_Boards_io;
